# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.44
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional

try:
    from pydantic.v1 import BaseModel, Field, StrictStr, conlist
except ModuleNotFoundError:
    from pydantic import BaseModel, Field, StrictStr, conlist
from pypureclient.flasharray.FA_2_44.models.fixed_reference_with_type import FixedReferenceWithType
from pypureclient.flasharray.FA_2_44.models.reference_with_type import ReferenceWithType


class ActiveDirectory(BaseModel):
    """
    ActiveDirectory
    """
    name: Optional[StrictStr] = Field(default=None, description="A locally unique, system-generated name. The name cannot be modified.")
    server: Optional[FixedReferenceWithType] = Field(default=None, description="Reference to the server the object belongs to. When the value is empty or set to `null` it means the object lives outside of a server scope.")
    computer_name: Optional[StrictStr] = Field(default=None, description="The name of the computer account in the Active Directory domain.")
    directory_servers: Optional[conlist(StrictStr)] = Field(default=None, description="A list of directory servers used for lookups related to user authorization. Servers must be specified in FQDN format. All specified servers must be registered to the domain appropriately in the configured DNS of the array and are only communicated with over the secure LDAP (LDAPS) protocol. If this field is `null`, the servers are resolved for the domain in DNS.")
    domain: Optional[StrictStr] = Field(default=None, description="The Active Directory domain joined.")
    kerberos_servers: Optional[conlist(StrictStr)] = Field(default=None, description="A list of key distribution servers to use for Kerberos protocol. Servers must be specified in FQDN format. All specified servers must be registered to the domain appropriately in the configured DNS of the array. If this field is `null`, the servers are resolved for the domain in DNS.")
    sources: Optional[conlist(ReferenceWithType)] = Field(default=None, description="List of network interfaces used for egress. For directory services at the array level, this list can be empty. If the list is empty, the system will use VIFs with the \"ds\" service (or if none, the \"management\" service) for egress.")
    tls: Optional[StrictStr] = Field(default=None, description="TLS mode for communication with domain controllers. Valid values are `required` and `optional`. `required` forces TLS communication with domain controller. `optional` allows the use of non-TLS communication, TLS will still be preferred, if available. If not specified, defaults to `required`.")
    __properties = ["name", "server", "computer_name", "directory_servers", "domain", "kerberos_servers", "sources", "tls"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "name",
                "computer_name",
                "directory_servers",
                "domain",
                "kerberos_servers",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of server
        if _include_in_dict('server', include_readonly, excluded_fields, none_fields):
            _dict['server'] = self.server.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of each item in sources (list)
        if _include_in_dict('sources', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.sources:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['sources'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> ActiveDirectory:
        """Create an instance of ActiveDirectory from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> ActiveDirectory:
        """Create an instance of ActiveDirectory from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ActiveDirectory.parse_obj(obj)

        _obj = ActiveDirectory.construct(_fields_set=None, **{
            "name": obj.get("name"),
            "server": FixedReferenceWithType.from_dict(obj.get("server")) if obj.get("server") is not None else None,
            "computer_name": obj.get("computer_name"),
            "directory_servers": obj.get("directory_servers"),
            "domain": obj.get("domain"),
            "kerberos_servers": obj.get("kerberos_servers"),
            "sources": [ReferenceWithType.from_dict(_item) for _item in obj.get("sources")] if obj.get("sources") is not None else None,
            "tls": obj.get("tls")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

