# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.44
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import List, Optional

try:
    from pydantic.v1 import BaseModel, Field, StrictBool, StrictStr, conlist, constr, validator
except ModuleNotFoundError:
    from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist, constr, validator
from pypureclient.flasharray.FA_2_44.models.directory_service_management import DirectoryServiceManagement
from pypureclient.flasharray.FA_2_44.models.fixed_reference import FixedReference
from pypureclient.flasharray.FA_2_44.models.reference_with_type import ReferenceWithType


class DirectoryService(BaseModel):
    """
    DirectoryService
    """
    id: Optional[StrictStr] = Field(default=None, description="A globally unique, system-generated ID. The ID cannot be modified and cannot refer to another resource.")
    name: Optional[StrictStr] = Field(default=None, description="A user-specified name. The name must be locally unique and can be changed.")
    context: Optional[FixedReference] = Field(default=None, description="The context in which the operation was performed. Valid values include a reference to any array which is a member of the same fleet. If the array is not a member of a fleet, `context` will always implicitly be set to the array that received the request. Other parameters provided with the request, such as names of volumes or snapshots, are resolved relative to the provided `context`.")
    base_dn: Optional[StrictStr] = Field(default=None, description="Base of the Distinguished Name (DN) of the directory service groups.")
    bind_password: Optional[StrictStr] = Field(default=None, description="Masked password used to query the directory.")
    bind_user: Optional[StrictStr] = Field(default=None, description="Username used to query the directory.")
    enabled: Optional[StrictBool] = Field(default=None, description="The directory service is either enabled or disabled.")
    services: Optional[conlist(StrictStr)] = Field(default=None, description="Services for which the directory service configuration is used.")
    uris: Optional[conlist(constr(strict=True))] = Field(default=None, description="List of URIs for the configured directory servers.")
    ca_certificate: Optional[StrictStr] = Field(default=None, description="The certificate of the Certificate Authority (CA) that signed the directory servers' certificate(s), which is used to validate the authenticity of the configured servers. Deprecated, please use ca_certificate_ref instead. Setting this field will result in ca_certificate_ref being updated to _legacy_ds_ca_certificate_<config_name>.")
    ca_certificate_ref: Optional[ReferenceWithType] = Field(default=None, description="Reference (ID, name, and resource type) of the Certificate Authority (CA) that signed the certificates of the directory servers, which is used to validate the authenticity of the configured servers.")
    check_peer: Optional[StrictBool] = Field(default=None, description="Determines whether or not server authenticity is enforced when a certificate is provided.")
    management: Optional[DirectoryServiceManagement] = None
    sources: Optional[conlist(ReferenceWithType)] = Field(default=None, description="List of network interfaces used for egress. For directory services at the array level, this list can be empty. If the list is empty, the system will use VIFs with the \"ds\" service (or if none, the \"management\" service) for egress.")
    __properties = ["id", "name", "context", "base_dn", "bind_password", "bind_user", "enabled", "services", "uris", "ca_certificate", "ca_certificate_ref", "check_peer", "management", "sources"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "id",
                "services",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of context
        if _include_in_dict('context', include_readonly, excluded_fields, none_fields):
            _dict['context'] = self.context.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of ca_certificate_ref
        if _include_in_dict('ca_certificate_ref', include_readonly, excluded_fields, none_fields):
            _dict['ca_certificate_ref'] = self.ca_certificate_ref.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of management
        if _include_in_dict('management', include_readonly, excluded_fields, none_fields):
            _dict['management'] = self.management.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of each item in sources (list)
        if _include_in_dict('sources', include_readonly, excluded_fields, none_fields):
            _items = []
            for _item in self.sources:
                if _item:
                    _items.append(_item.to_dict(include_readonly=include_readonly))
            _dict['sources'] = _items
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> DirectoryService:
        """Create an instance of DirectoryService from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> DirectoryService:
        """Create an instance of DirectoryService from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DirectoryService.parse_obj(obj)

        _obj = DirectoryService.construct(_fields_set=None, **{
            "id": obj.get("id"),
            "name": obj.get("name"),
            "context": FixedReference.from_dict(obj.get("context")) if obj.get("context") is not None else None,
            "base_dn": obj.get("base_dn"),
            "bind_password": obj.get("bind_password"),
            "bind_user": obj.get("bind_user"),
            "enabled": obj.get("enabled"),
            "services": obj.get("services"),
            "uris": obj.get("uris"),
            "ca_certificate": obj.get("ca_certificate"),
            "ca_certificate_ref": ReferenceWithType.from_dict(obj.get("ca_certificate_ref")) if obj.get("ca_certificate_ref") is not None else None,
            "check_peer": obj.get("check_peer"),
            "management": DirectoryServiceManagement.from_dict(obj.get("management")) if obj.get("management") is not None else None,
            "sources": [ReferenceWithType.from_dict(_item) for _item in obj.get("sources")] if obj.get("sources") is not None else None
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

