# coding: utf-8

"""
    FlashArray REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 2.44
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union

try:
    from pydantic.v1 import BaseModel, Field, StrictFloat, StrictInt, StrictStr
except ModuleNotFoundError:
    from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from pypureclient.flasharray.FA_2_44.models.directory_user_quota_rule import DirectoryUserQuotaRule
from pypureclient.flasharray.FA_2_44.models.fixed_reference import FixedReference
from pypureclient.flasharray.FA_2_44.models.fixed_reference_with_type import FixedReferenceWithType
from pypureclient.flasharray.FA_2_44.models.user_group import UserGroup


class DirectoryUserQuota(BaseModel):
    """
    DirectoryUserQuota
    """
    context: Optional[FixedReference] = Field(default=None, description="The context in which the operation was performed. Valid values include a reference to any array which is a member of the same fleet. If the array is not a member of a fleet, `context` will always implicitly be set to the array that received the request. Other parameters provided with the request, such as names of volumes or snapshots, are resolved relative to the provided `context`.")
    directory: Optional[FixedReferenceWithType] = Field(default=None, description="The directory with the user-group-quota policy attached.")
    path: Optional[StrictStr] = Field(default=None, description="Absolute path of the managed directory in the file system.")
    percentage_used: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The ratio of the quota usage to the quota limit. The usage has reached the quota limit if it reaches 1.0.")
    quota_usage: Optional[StrictInt] = Field(default=None, description="The total usage owned by the user that is accountable to the user-group-quota policy rules, measured in bytes. The applicable rules may be enforced or unenforced.")
    rule: Optional[DirectoryUserQuotaRule] = Field(default=None, description="The user-group-quota rule that applies to the user.")
    user: Optional[UserGroup] = Field(default=None, description="The user for which the user-group-quota policy rules apply.")
    user_email: Optional[StrictStr] = Field(default=None, description="The email address of the user.")
    __properties = ["context", "directory", "path", "percentage_used", "quota_usage", "rule", "user", "user_email"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "path",
                "percentage_used",
                "quota_usage",
                "user_email",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of context
        if _include_in_dict('context', include_readonly, excluded_fields, none_fields):
            _dict['context'] = self.context.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of directory
        if _include_in_dict('directory', include_readonly, excluded_fields, none_fields):
            _dict['directory'] = self.directory.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of rule
        if _include_in_dict('rule', include_readonly, excluded_fields, none_fields):
            _dict['rule'] = self.rule.to_dict(include_readonly=include_readonly)
        # override the default output from pydantic by calling `to_dict()` of user
        if _include_in_dict('user', include_readonly, excluded_fields, none_fields):
            _dict['user'] = self.user.to_dict(include_readonly=include_readonly)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> DirectoryUserQuota:
        """Create an instance of DirectoryUserQuota from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> DirectoryUserQuota:
        """Create an instance of DirectoryUserQuota from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DirectoryUserQuota.parse_obj(obj)

        _obj = DirectoryUserQuota.construct(_fields_set=None, **{
            "context": FixedReference.from_dict(obj.get("context")) if obj.get("context") is not None else None,
            "directory": FixedReferenceWithType.from_dict(obj.get("directory")) if obj.get("directory") is not None else None,
            "path": obj.get("path"),
            "percentage_used": obj.get("percentage_used"),
            "quota_usage": obj.get("quota_usage"),
            "rule": DirectoryUserQuotaRule.from_dict(obj.get("rule")) if obj.get("rule") is not None else None,
            "user": UserGroup.from_dict(obj.get("user")) if obj.get("user") is not None else None,
            "user_email": obj.get("user_email")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

