# coding: utf-8

"""
    FlashBlade REST API

    A lightweight client for FlashBlade REST API 2.18, developed by Pure Storage, Inc. (http://www.purestorage.com/).

    The version of the OpenAPI document: 2.18
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json
from typing import Set, Dict, Any

from typing import Optional, Union

try:
    from pydantic.v1 import BaseModel, Field, StrictFloat, StrictInt
except ModuleNotFoundError:
    from pydantic import BaseModel, Field, StrictFloat, StrictInt


class HardwareTemperaturesThresholds(BaseModel):
    """
    The predefined temperature thresholds for the sensor, specifying acceptable operational limits.
    """
    critical: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The temperature level indicating that the system is under increased load. While still operational, it may require monitoring or adjustments to maintain optimal performance.")
    non_critical: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The temperature level at which the system operates normally without any concerns.")
    unrecoverable: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The maximum temperature limit beyond which the system may experience irreversible failure. Immediate action is required to prevent damage or shutdown.")
    __properties = ["critical", "non_critical", "unrecoverable"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.to_dict(include_readonly=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.as_request_dict())

    def as_request_dict(self) -> Dict[str, Any]:
        return self.to_dict(include_readonly=False)

    def to_dict(self, include_readonly: bool=True) -> Dict[str, Any]:

        """Returns the dictionary representation of the model using alias"""
        excluded_fields: Set[str] = set()
        if not include_readonly:
            excluded_fields.update([
                "critical",
                "non_critical",
                "unrecoverable",
            ])
        none_fields: Set[str] = set()
        for _field in self.__fields__.keys():
            if super().__getattribute__(_field) is None:
                none_fields.add(_field)

        _dict = self.dict(by_alias=True, exclude=excluded_fields, exclude_none=True)
        return _dict

    def __getitem__(self, key):
        return super().__getattribute__(key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def __delitem__(self, key):
        setattr(self, key, None)

    def __getattribute__(self, name: str) -> Any:
        _value = super().__getattribute__(name)
        if _value is None and name in self.__fields__.keys() and _should_raise_on_none():
            raise AttributeError
        return _value

    def __str__(self) -> str:
        return self.to_str()

    def __repr__(self) -> str:
        return self.to_str()

    @classmethod
    def from_json(cls, json_str: str) -> HardwareTemperaturesThresholds:
        """Create an instance of HardwareTemperaturesThresholds from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    @classmethod
    def from_dict(cls, obj: dict) -> HardwareTemperaturesThresholds:
        """Create an instance of HardwareTemperaturesThresholds from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HardwareTemperaturesThresholds.parse_obj(obj)

        _obj = HardwareTemperaturesThresholds.construct(_fields_set=None, **{
            "critical": obj.get("critical"),
            "non_critical": obj.get("non_critical"),
            "unrecoverable": obj.get("unrecoverable")
        })
        return _obj

def _should_raise_on_none() -> bool:
    import importlib
    _package = importlib.import_module(__package__)
    return _package._attribute_error_on_none

def _include_in_dict(name: str, include_readonly: bool, excluded_fields: Set[str], none_fields: Set[str]) -> bool:
    if name in none_fields:
        return False
    return (include_readonly or name not in excluded_fields)

